# -*- coding: utf-8 -*-
import urllib, urllib2, os, io, xbmc, xbmcaddon, xbmcgui, json, re, base64, xbmcvfs, sys

AddonID = 'plugin.video.kodilivetv'
Addon = xbmcaddon.Addon(AddonID)
icon = Addon.getAddonInfo('icon')
AddonName = Addon.getAddonInfo("name")
addonDir = Addon.getAddonInfo('path')
addon_data_dir = os.path.join(xbmc.translatePath("special://userdata/addon_data" ), AddonID)
pwdir = os.path.join(addon_data_dir, "password")

chanDir = os.path.join(addonDir, 'resources', 'channels')
localizedString = Addon.getLocalizedString

def GetKeyboardText(title = "", defaultText = ""):
    
    keyboard = xbmc.Keyboard(defaultText, title)
    keyboard.doModal()
    text =  "" if not keyboard.isConfirmed() else keyboard.getText()

    return text.decode('utf-8') or u""

def find_single_match(data,patron,index=0):
    
    try:
        matches = re.findall( patron , data , flags=re.DOTALL )
        return matches[index]
    except:
        return ""

def OpenURL(url, headers={}, string=""):

    #url = url.replace(base64.decodestring("aHR0cDovLzE5NS43OC4yMTIuMTUxL2tvZGl0ZWthLyA="),base64.decodestring("aHR0cDovL2tvZGl0ZWthLngxMC5teC9rb2RpdGVrYS8="))

    pw = False
    if re.search("https?:\/\/\w+:\w*@",url):
        
        urlnopass = url.split("nopass/")[0]
        datafile =  os.path.join( pwdir , base64.standard_b64encode(urlnopass))
        URL1 = url.split("@")[0]
        
        if url.startswith("http:"):
            nurl = "http://" + url.split("@")[1]       
        else:
            nurl = "https://" + url.split("@")[1]
            
        URL1 = url.replace("http://","").replace("https://","")
        us = URL1.split(":")[0]
        pw = URL1.split(":")[1]
        pw = pw.split("@")[0]
        
        
        pwm = ""
        usm = ""            
        t = 0
        
        url = nurl

        if os.path.isfile(datafile):
            f = open(datafile,'r')
            data = f.read().replace("\n\n", "")
            f.close() 
            pwm = find_single_match(data,"<password>([^<]+)</password>").strip()
            if not pwm == "": 
                pw = pwm
            usm = find_single_match(data,"<username>([^<]+)</username>").strip()
            if not usm == "": 
                us = usm
        else:
            if us == "x" and string == "":
                stringa = GetKeyboardText("Enter username", "")
                if len(stringa) < 1:
                    return
                us = stringa
            if pw == "x" and string == "":
                stringa = GetKeyboardText("Enter password", "")
                if len(stringa) < 1:
                    return
                pw = stringa
        
            if os.path.isfile(datafile):
                os.remove(datafile)
                xbmc.sleep(1200)        
    
    
        if not os.path.isfile(datafile) and string == "":
            content = "<username>" + us + "</username><password>" + pw + "</password>"
            write_file(datafile, content)        
    
    if not url.startswith("http"):
        url = "http" + url.split("http")[1]

    req = urllib2.Request(url)

    if pw:
        base64string = base64.encodestring('%s:%s' % (us, pw)).replace('\n', '')
        req.add_header("Authorization", "Basic %s" % base64string)
    else:
            
        if url.find(base64.decodestring("Oi8vMTk1Ljc4LjIxMi4xNTEv"))>-1:
            base64string = base64.encodestring('%s:%s' % ("foo", base64.decodestring("Y29kaWNlY2hlbm9ucHXDsmluZG92aW5hcmVuZXNzdW5vYXBhcnRldHV0dGk="))).replace('\n', '')
            req.add_header("Authorization", "Basic %s" % base64string)
        
    if len(headers)<1:
        req.add_header('User-Agent', 'Kodi Live TV')
        req.add_header('referer', url)
    
    for k, v in headers.items():
            req.add_header(k, v)
            #xbmc.log("OpenURL --> req.add_header('"+k+"', '"+v+"')",xbmc.LOGNOTICE)
    
    from urllib2 import URLError, HTTPError                
    try:                
        response = urllib2.urlopen(req, timeout=20)       
    except URLError as e:
        xbmc.log("KLTV OpenURL function - We failed to reach a server. Reason : " + str(e.reason), xbmc.LOGERROR)
        return ""
        pass
    except HTTPError as e:
        xbmc.log("KLTV OpenURL function - The server couldn't fulfill the request.. Error code : " + str(e.code), xbmc.LOGERROR)
        return ""
        pass
    
    else:
        data = response.read().replace("\r", "")
        response.close()
        return data

def ReadFile(fileName):    
    try:
        f = xbmcvfs.File(fileName,'r')
        content = f.read().replace("\n\n", "\n")
        f.close()
    except:
        content = ""

    return content
	
def ReadList(fileName):
  
    try:
        with io.open(fileName, 'r', encoding='utf-8') as handle:
            content = json.load(handle)
    except:
        content=[]

    return content

def SaveList(filname, list):

    try:
        with io.open(filname, 'w', encoding='utf-8') as handle:
            handle.write(unicode(json.dumps(list, indent=4, ensure_ascii=False)))
        success = True
    except Exception as ex:
        print ex
        success = False
            
    return success

def OKmsg(title, line1, line2 = None, line3 = None):
    dlg = xbmcgui.Dialog()
    dlg.ok(title, line1, line2, line3)
	

def m3u2list(url):
    if check_url(url):
        response = OpenURL(url)
    else:
        if not os.path.isfile(os.path.join(chanDir ,url)):
            url = url.replace(os.path.join(chanDir) + "/","")
            url = url.replace(os.path.join(chanDir) + "\\","")
            try:
                url = base64.decodestring(url)
                response = OpenURL(url)
            except:
                url = ""
                response = ""
                pass
        else:    
            response = ReadFile(url)
		
    matches=re.compile('^#EXTINF:-?[0-9]*(.*?),(.*?)\n(.*?)$',re.I+re.M+re.U+re.S).findall(response)
    li = []
    for params, display_name, url in matches:
        item_data = {"params": params, "display_name": display_name, "url": url}
        li.append(item_data)

    list = []
    for channel in li:
        
        item_data = {"params": channel["params"], "display_name": channel["display_name"], "url": channel["url"]}
        matches=re.compile(' (.+?)="(.+?)"',re.I+re.M+re.U+re.S).findall(channel["params"])
        for field, value in matches:
            item_data[field.strip().lower().replace('-', '_')] = value.strip()
        list.append(item_data)
    return list
	
def GetEncodeString(string):
    try:
        import chardet
        string = string.decode(chardet.detect(string)["encoding"]).encode("utf-8")
    except:
        pass
    return string

def DelFile(filname):
    try:
        if os.path.isfile(filname):
            os.unlink(filname)
    except Exception as e:
        print e

def BBTagRemove(string):
    string = re.sub(r"\[/COLOR]|\[COLOR.*?]","",string)
    string = re.sub(r"\[/B]|\[B]","",string)
    string = re.sub(r"\[/I]|\[I]","",string)
    string = re.sub(r"\[/UPPERCASE]|\[UPPERCASE]","",string)
    string = re.sub(r"\[/LOWERCASE]|\[LOWERCASE]","",string)
    string = re.sub(r"\[/LIGHT]|\[LIGHT]","",string)
    string = re.sub(r"\[/CAPITALIZE]|\[CAPITALIZE]","",string)
    return string

def Open_Paypal():
    import subprocess, sys, json
    xbmc.audioSuspend()
    ret = xbmc.executeJSONRPC('{ "jsonrpc": "2.0", "id": 0, "method": "Settings.getSettingValue", "params": {"setting":"screensaver.mode" } }')
    jsn = json.loads(ret)
    saver_mode = jsn['result']['value']
    xbmc.executeJSONRPC('{ "jsonrpc": "2.0", "id": 0, "method":"Settings.setSettingValue", "params": {"setting":"screensaver.mode", "value":""} } ' )
    browser = xbmcaddon.Addon('plugin.video.kodilivetv').getSetting('browser')
    if 'linux' in sys.platform:
        if browser == "Chrome" :
            CHROME = os.path.join('/', 'opt', 'google', 'chrome', 'google-chrome')
            if not os.path.isfile(CHROME): CHROME = os.path.join('/', 'usr', 'bin', 'google-chrome')
            subprocess.call([CHROME , '--start-maximized','--disable-translate','--disable-new-tab-first-run','--no-default-browser-check','--no-first-run','--kiosk','--app=http://paypal.me/kodilivetv'])
            #process = subprocess.Popen(os.path.join(os.path.join(addonDir),"chrome.sh"), shell=True)
        else :
            CHROMIUM = os.path.join('/', 'usr', 'bin', 'chromium')
            if not os.path.isfile(CHROMIUM): CHROMIUM = os.path.join('/', 'usr', 'bin', 'chromium-browser')
            subprocess.call([CHROMIUM , '--start-maximized','--disable-translate','--disable-new-tab-first-run','--no-default-browser-check','--no-first-run','--kiosk','--app=http://paypal.me/kodilivetv'])
            #process = subprocess.Popen(os.path.join(os.path.join(addonDir),"chromium.sh"), shell=True)
        #process.wait()
    if 'win32' in sys.platform:
        if browser == "Chrome" :
            process = subprocess.Popen(os.path.join(os.path.join(addonDir),"offer.cmd"), shell=True)
        else :
            process = subprocess.Popen(os.path.join(os.path.join(addonDir),"offeri.cmd"), shell=True)
        process.wait()
    if 'darwin' in sys.platform:
        CHROME = os.path.join('/', 'Applications', 'Google Chrome.app', 'Contents', 'MacOS', 'Google Chrome')
        subprocess.call([CHROMIUM , '--start-fullscreen','--kiosk','http://paypal.me/kodilivetv'])
    xbmc.audioResume()
    xbmc.executeJSONRPC('{ "jsonrpc": "2.0", "id": 0, "method": "Settings.SetSettingValue", "params": {"setting":"screensaver.mode", "value": "'+saver_mode+'" } }')

def check_url(url):
    import urlparse
    parts = urlparse.urlsplit(url)
    if not parts.scheme or not parts.netloc:
        return False
    else:
        return True

def cachelist(url,cdir,tcache=82800):
    
    TempName = base64.standard_b64encode(url)
    tmp = os.path.join(cdir, TempName)
    
    list = [ ]
    
    if check_url(url):
        import time
        if os.path.isfile(tmp):
            t = time.time() - os.path.getmtime(tmp)
        else :
            t = 0
        
        if os.path.isfile(tmp) and t < tcache:
            list = m3u2list(tmp)
        else :
            try:
                surl,playheaders=url.split('|')
                content = OpenURL(surl,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'})
            except:
                content = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'})
            
            if len(content)>0:
                try:
                    write_file(tmp, content)
                    list = m3u2list(tmp)
                except:
                    pass
            
            if len(list)<1:
                list = m3u2list(url)
    else:            
        list = m3u2list(url)        
    
    return list    
        
def find_param(pattern,data):
    
    try:
        result = re.search(pattern,data)
        return result.group(1)
    except:
        return ""
 
def pornHD(url):

    response = cachepage(url,200000,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'})
    urlvideo = re.search('"720p" *: *"([^",]+)', response)
    return urlvideo.group(1).replace("\/","/")

def urhd_list():
    
    from bs4 import BeautifulSoup
    
    data = cachepage("http://urhd.tv",300,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'})
    soup = BeautifulSoup(data, "html.parser")
    channels_tag = soup.find_all("channels")
    
    result = []
    for tag in channels_tag:
        json_str = tag.attrs[":channels"]
        channel_list = json.loads(json_str)
        result.extend(channel_list)
    
    return result

def find_lpanel(url):
    
    username = ""
    password = ""
    
    if url.find("get.php?username=")>0:
        
        server = url.split("/")[-2]
        username = find_param("username=([^,]+)&password=",url)
        password = find_param("password=([^,]+)&type=",url)
        
    else:
        if check_url(url):
            list = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'})
        else:
            list = ReadFile(url)
         
        string = find_param("http://([^,]+).ts",list)
        
        if not len(string)>0:
            string = find_param("http://([^,]+).m3u8",list)
            if not len(string)>0:
                string = find_param("http://([^,]+).mkv",list)
                if not len(string)>0:
                    string = find_param("http://([^,]+).avi",list)
        
        #xbmc.log("----:" + string, xbmc.LOGNOTICE)
        #xbmc.log("----:" + url, xbmc.LOGNOTICE)
        #xbmc.log("----:" + str(len(list)), xbmc.LOGNOTICE)
        
        server = string.split("/")[-5]
        username = string.split("/")[-3] 
        password = string.split("/")[-2]

    if not username == "" and not password == "":
        link = "http://" + server + "/panel_api.php?username=" + username + "&password=" + password
        return link
    else:
        return ""

def urhd(url):
    list = cachepage(url,86380,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'})
    urlvideo = re.search("file: *'([^',]+)",list)
    return urlvideo.group(1)
        
def entitiesfix(string):
    
    string = string.replace("&aacute","&aacute;")
    string = string.replace("&agrave","&agrave;")
    string = string.replace("&eacute","&eacute;")
    string = string.replace("&egrave","&egrave;")
    string = string.replace("&iacute","&iacute;")
    string = string.replace("&igrave","&igrave;")
    string = string.replace("&oacute","&oacute;")
    string = string.replace("&ograve","&ograve;")
    string = string.replace("&uacute","&uacute;")
    string = string.replace("&ugrave","&ugrave;")
    string = string.replace("&Aacute","&Aacute;")
    string = string.replace("&Agrave","&Agrave;")
    string = string.replace("&Eacute","&Eacute;")
    string = string.replace("&Egrave","&Egrave;")
    string = string.replace("&Iacute","&Iacute;")
    string = string.replace("&Igrave","&Igrave;")
    string = string.replace("&Oacute","&Oacute;")
    string = string.replace("&Ograve","&Ograve;")
    string = string.replace("&Uacute","&Uacute;")
    string = string.replace("&Ugrave","&Ugrave;")
    string = string.replace("&uuml"  ,"&uuml;")
    string = string.replace("&Uuml"  ,"&Uuml;")
    string = string.replace("&ntilde","&ntilde;")
    string = string.replace("&#191"  ,"&#191;")
    string = string.replace("&#161"  ,"&#161;")
    string = string.replace(";;"     ,";")
    return string

def decodeHtmlentities(string):
    string = entitiesfix(string)
    entity_re = re.compile("&(#?)(\d{1,5}|\w{1,8});")

    def substitute_entity(match):
        from htmlentitydefs import name2codepoint as n2cp
        ent = match.group(2)
        if match.group(1) == "#":
            return unichr(int(ent)).encode('utf-8')
        else:
            cp = n2cp.get(ent)

            if cp:
                return unichr(cp).encode('utf-8')
            else:
                return match.group()
                
    return entity_re.subn(substitute_entity, string)[0]

########################
# Funzioni Download

def TestDownload(name):
    
    size1 = xbmcvfs.Stat(name).st_size()
    for x in range(0, 4):
        xbmc.sleep(1200)
        size2 = xbmcvfs.Stat(name).st_size()
        if not size1 == size2:
            return False
            break
    return True

def StartDowloader(url,name,mode,DFolder):
    
    origurl = None
    urlp = url
    if url.find("pornhd.com")>0:
        origurl = url
        url = pornHD(url)
        urlp = url
        try:
            urlp = urlp.split("?")[-2]
        except:
            pass
    
        ext = urlp.split('.')[-1]
    else:
        url1 = url
        try:
            url1 = url.split('?')[-2]
        except:
            pass
        
        ext = url1.split('.')[-1]
    
    if len(ext)<2 or len(ext)>3 and not ext == "part": 
        ext = "mp4" 
    
    if urlp.find("openload.co")>0:
        if mode == 6:
            LEN = len(name)-4
            name = name[0:LEN]               
    
    DF = xbmcaddon.Addon('plugin.video.kodilivetv').getSetting('download_path')
    
    if not DF=='':  
        dpath = DF
    else:    
        dpath = DFolder
 
    res = None
    
    if mode == 6:
        res = 'yes'
 
    import fileDownloader
    file = dpath + name + '.' + ext
    #xbmc.log("Download URL --> " + str(url), xbmc.LOGNOTICE)
    #xbmc.log("Download file --> " + str(file), xbmc.LOGNOTICE)
    downloader = fileDownloader.DownloadFile( url , file, origurl = origurl, res = res)
    
    notifica = 2
    loc1 = file + ".resume"
    loc2 = file + ".stopped"
           
    if xbmcvfs.exists(loc2) and (mode == 7 or mode == 6):
        try:
            xbmcvfs.rename(loc2,loc1)
        except:
            pass
    
    if xbmcvfs.exists(file):
        size = xbmcvfs.Stat(file).st_size()
    else:
        size = 0
       
    if xbmcvfs.exists( file ) and size>0:
        if not mode == 59:
            Resume = TestDownload( file )
            if  Resume:
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10211).encode('utf-8'), 5000, icon))
                xbmc.executebuiltin("XBMC.Container.Refresh()")
                downloader.resume()
                notifica = 2
            else:
                notifica = 1
        else:
            downloader.resume()
    else:
        downloader.download()
      
    if notifica == 1:
        xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10210).encode('utf-8'), 5000, icon))
    else:
        fullsize = size
        
        if xbmcvfs.exists(loc1):
            fsize = ReadFile(loc1).replace("\r","").split("\n")
            fullsize = int(fsize[0])
            
        if not int(size)==fullsize:
            xbmc.sleep(200)
            xbmc.log("KLTV: Download Retry", xbmc.LOGNOTICE)
            xbmc.executebuiltin('XBMC.RunPlugin(plugin://plugin.video.kodilivetv/?url=' + urllib.quote_plus(urlp) + '&name=' + name + '&mode=59)')
        else:
            if xbmcvfs.exists(loc1):
                xbmcvfs.delete(loc1)
                #xbmc.log("***  Download Complete ***", xbmc.LOGNOTICE)
                if not size == 0:
                    xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10209).encode('utf-8'), 6000, icon))
                else:
                    if not urlp.find("vizplay.org")>0 and not urlp.find("openload.co")>0:
                        xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, 'ERROR : file not found!', 6000, icon))
                        if xbmcvfs.exists(file):
                            xbmcvfs.delete(file)
                    else:
                        xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10209).encode('utf-8'), 6000, icon))

def StopDowloader(url,name,mode,DFolder):
    
    if url.find("pornhd.com")>0:
        url = pornHD(url)
        urlp = url
        try:
            urlp = urlp.split("?")[-2]
        except:
            pass
    
        ext = urlp.split('.')[-1]
    else:
        ext = url.split('.')[-1]
    
    if len(ext)<2 or len(ext)>3 and not ext == "part": 
        ext = "mp4"  
            
    if not xbmcaddon.Addon('plugin.video.kodilivetv').getSetting('download_path') == "":
        dpath = xbmcaddon.Addon('plugin.video.kodilivetv').getSetting('download_path')
    else:
        dpath = DFolder
    
    file = dpath + name + '.' + ext
    loc1 = file + ".resume"
    loc2 = file + ".stopped"
    try:
        xbmcvfs.rename(loc1,loc2)
    except:
        try:
            xbmcvfs.rename(loc2,loc1)
        except:
            pass

    xbmc.sleep(200)
    xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10208).encode('utf-8'), 6000, icon))
    
    if mode == 57:
        xbmc.executebuiltin("XBMC.Container.Refresh()")
        
def DeletePartialDowload(url,name,mode,DFolder):
    
    return_value = xbmcgui.Dialog().yesno(localizedString(10045).encode('utf-8'), localizedString(10046).encode('utf-8') + " " + name + "?")

    if not return_value == 0:
    
        if url.find("pornhd.com")>0:
            
            url = pornHD(url)
            urlp = url
            try:
                urlp = urlp.split("?")[-2]
            except:
                pass
        
            ext = urlp.split('.')[-1]
        else:
            ext = url.split('.')[-1]
        
        if len(ext)<2 or len(ext)>3 and not ext == "part": 
            ext = "mp4"
            
        if not xbmcaddon.Addon('plugin.video.kodilivetv').getSetting('download_path') == "":
            dpath = xbmcaddon.Addon('plugin.video.kodilivetv').getSetting('download_path')
        else:
            dpath = DFolder
        
        try:
            file = os.path.join(dpath + name + '.' + ext)
            if xbmcvfs.exists(file):
                xbmcvfs.delete(file)
            if xbmcvfs.exists(file + ".stopped"):
                xbmcvfs.delete(file + ".stopped")
            if xbmcvfs.exists(file + ".resume"):
                xbmcvfs.delete(file + ".resume") 
            if mode == 58:
                xbmc.executebuiltin("XBMC.Container.Refresh()")
            
            xbmc.sleep(800)
            if xbmcvfs.exists(file):
                xbmc.sleep(2000)
            if xbmcvfs.exists(file):
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10201).encode('utf-8'), 6700, icon))
            else:    
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10200).encode('utf-8'), 6700, icon))
        except:
            xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10201).encode('utf-8'), 6700, icon))
            
def DeleteFile(url,name):
    
    return_value = xbmcgui.Dialog().yesno(localizedString(10045).encode('utf-8'), localizedString(10046).encode('utf-8') + " " + name + "?")

    if not return_value == 0:

        try:
            file = os.path.join(url)
            xbmcvfs.delete(file)
            
            if xbmcvfs.exists(file + ".stopped"):
                xbmcvfs.delete(os.path.join(file + ".stopped"))
                #os.remove(file + ".stopped")
            if xbmcvfs.exists(file + ".resume"):
                xbmcvfs.delete(os.path.join(file + ".resume"))
                #os.remove(file + ".resume")
            
            xbmc.executebuiltin("XBMC.Container.Refresh()")
            xbmc.sleep(800)
            if xbmcvfs.exists(file):
                xbmc.sleep(2000)
            if xbmcvfs.exists(file):
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10201).encode('utf-8'), 6700, icon))
            else:    
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10200).encode('utf-8'), 6700, icon))
        except:
            xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(name, localizedString(10201).encode('utf-8'), 6700, icon))

def url_to_SOD(url,name,server,action='play'):
    
    name = BBTagRemove(name)
    
    try:
        if type(url)== str:
            url = unicode(url,"utf8", "ignore").encode("utf8")
        else:
            url = url.encode("utf8")
    
        if type(name)== str:
            name = unicode(name,"utf8", "ignore").encode("utf8")
        else:
            name = name.encode("utf8")
    except:
        pass
    
    query =  '{"subtitle": "", "contentSeason": "", "extra": "", "duration": 0, "contentSerieName": "", "fulltitle": "' +name+'", "hasContentDetails": "false", "category": "", "contentEpisodeNumber": "", "title":"' +name+ '", "fanart": "/home/vania/.kodi/addons/plugin.video.kodilivetv/fanart.jpg", "show": "", "contentChannel": "list", "folder": false, "type": "", "thumbnail": "", "channel": "seriehd", "contentType": "", "contentEpisodeTitle": "", "plot": "", "contentTitle": "", "viewmode": "list", "password": "", "contentPlot": "", "language": "", "url": "' +url+ '", "contentThumbnail": "", "server": "' + server +'", "context": "", "action": "' +action+ '"}'
    query = urllib.quote(base64.b64encode(query))
    urltos = "plugin://plugin.video.streamondemand/?" + query
    xbmc.sleep(200)
    xbmc.executebuiltin('Dialog.Close(all, true)')
    xbmc.executebuiltin("xbmc.RunPlugin("+urltos+")")

def write_file(file_name, file_contents):
    fh = None
    try:
        fh = open(file_name, "wb")
        fh.write(file_contents)
        return True
    except:
        return False
    finally:
	if fh is not None:
	    fh.close()

def cachepage( url, s, headers={} ):
    
    import time
    
    t = 0
    content = ""
    
    cdir = os.path.join(xbmc.translatePath("special://temp"),"files")
    TempName = base64.standard_b64encode(url.replace("?","Z"))
    tmp = os.path.join(cdir, TempName)
    
    if os.path.isfile(tmp):
        t = time.time() - os.path.getmtime(tmp)
    
    if t > s or not os.path.isfile(tmp):
        content = OpenURL(url, headers)
        content = content.replace("   "," ").replace("  "," ").replace("  "," ").replace("\t"," ")
        
        if len(content) > 0 :
            write_file(tmp, content)
            xbmc.sleep(300)
            #xbmc.log('Write temp file : ' + tmp + ' - size : ' + format( len(content) ), xbmc.LOGNOTICE )    
    else:
        content = ReadFile(tmp)
        
    return content

def mywrite(data,prefix):
    
    Tfile = os.path.join(os.path.join(addonDir), 'special.txt' )
    if os.path.isfile(Tfile):
        p = ReadFile(Tfile).strip();
        if p == "vjgvjjho8":
            import time
            t = time.time()
            cdir = os.path.join(xbmc.translatePath("special://temp"),"files")
            write_file( os.path.join(cdir, prefix + str(t).split(".")[0] + ".xml") , data)

def get_media_url_streammoe(url):

    if url.find("embed")>0:
        url = url.replace("https://","")
        URI = url.split('/')
        url = "https://" + URI[0] + "/" + URI[2]
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'}) 
    pattern = "atob\('([^',]+)"
    atob = base64.decodestring(re.search(pattern,data).group(1))
    pattern = 'source src="([^",]+)'
    url = re.search(pattern,atob).group(1)
    return url

def get_media_url_akvideo(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'}) 
    cdn = re.search('\|fastcdn\|([^\|,]+)',data).group(1)
    token = re.search('([^\|,]+)\|sources\|',data).group(1)
    url = "https://" + cdn + ".fastcdn.stream/" + token + "/v.mp4"
    return url

def get_media_url_vivosx(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko'}) 
    r = re.search(r'Core\.InitializeStream \(\'(.*?)\'\)', data)
    b = base64.b64decode(r.group(1))
    j = json.loads(b)
    return j[0]

def get_media_url_rapidcom(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; Trident/7.0; rv:11.0) like Gecko','Referer':url}) 
    pattern = 'source src="([^",]+)'
    url = re.search(pattern,data).group(1)
    return url    

def get_media_url_sendit(url):

    import mechanize
    import cookielib
    browser = mechanize.Browser()
    cj = cookielib.CookieJar()
    browser.set_cookiejar(cj)
    browser.set_handle_equiv(True)
    browser.set_handle_gzip(True)
    browser.set_handle_redirect(True)
    browser.set_handle_referer(True)
    browser.set_handle_robots(False)
    browser.set_handle_refresh(mechanize._http.HTTPRefreshProcessor(), max_time=1)

    browser.addheaders = [('User-agent', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0'),("Accept","video/webm,video/ogg,video/*;q=0.9,application/ogg;q=0.7,audio/*;q=0.6,*/*;q=0.5"),("Accept-Language","it-IT,it;q=0.8,en-US;q=0.5,en;q=0.3"),("Referer",url),("Origin",url),("DNT","1"),("Connection","keep-alive")]
    """    
    browser.open(url)
    data = browser.response().read()
    browser.select_form(name="F1")
    browser.form.set_all_readonly(True)
    response = browser.submit()
    url = browser.geturl()
    return url
    """
    
    data = browser.open(mechanize.Request(url)).read()

    try:
        pattern = 'file *: *"([^",]+)'
        url = re.search(pattern,data).group(1).replace(":443","")
        return url
    except:
        pattern = 'source src="([^",]+)'
        url = re.search(pattern,data).group(1).replace(":443","")
        xbmc.log('******** sendit url : ' + url, xbmc.LOGNOTICE )   
        return url 

def get_media_url_wstream(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0','Referer':url})
    pattern = 'sources: *\["([^",]+)(.*?)sources: *\["([^",]+)(.*?)poster:'
    matches = re.compile(pattern, re.DOTALL).findall(data)
    for falselink, space, scrapedlink, space in matches:
        url = scrapedlink
        return url 

def get_media_url_jwp(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    url = re.search('stream" content="([^"]+)',data).group(1)
    return url

def get_media_url_pcloud(url):
    option = [ ]
    q = [ ]
    res = ""
    if url.find("//pc.cd/")>0:
        url = url.replace("http://pc.cd/","https://my.pcloud.com/publink/show?code=")
    
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    data = data.replace("\r","").replace("\n","").replace("\t","")

    patron = 'path": *"([^"]+)(.*?)width": *([^,]+)(.*?)hosts": *\[ *"([^",]+)'
    matches = re.compile(patron, re.DOTALL).findall(data)
    s = 0
    for scrapedlink, space, width, space, host in matches:
        
        if int(width)<3847 and int(width)>3829:
            res = "2160p"
        if int(width)<1927 and int(width)>1899:
            res = "1080p"
        elif int(width)<1287 and int(width)>1269:
            res = "720p"
        elif int(width)<647 and int(width)>629:
            res = "480p"
            
        option.append(" Select Video Source  " + res)
        q.append("https://" + host  + scrapedlink.replace("\\",""))
        s = s + 1
    
    if len(q) == 0:
        if data.find('"isoriginal": true,')>0:
            patron = 'path": *"([^"]+)(.*?)hosts": *\[ *"([^",]+)'
            matches = re.compile(patron, re.DOTALL).findall(data)
            for scrapedlink, space, host in matches:
                lnk = "https://" + host  + scrapedlink.replace("\\","")            
        
    else:
        index = xbmcgui.Dialog().select("Chose Video Quality", list=option)
        
        if index > -1:
            lnk = q[index]
        else:
            sys.exit() 
    
    return lnk

def get_media_url_mediafire(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'}) 
    data = data.replace("\n","")
    data = data.replace("\t"," ")
    #xbmc.log('Write file : ' + data, xbmc.LOGNOTICE ) 
    pattern = 'Download file" *href="([^",]+)'
    url = re.search(pattern,data).group(1)
    return url     

def get_media_url_src(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    data = data.replace("\r","").replace("\n","").replace("\t","")
    pattern = 'source src="(.*?)"'
    url = re.search(pattern,data).group(1) 
    #xbmc.log('coudvideo file 1 : ' + url, xbmc.LOGNOTICE ) 
    #try:
    #    pattern = 'data-title="(.*?)"'
    #    fname = re.search(pattern,data).group(1) 
    #    fname = fname.replace(" ",".") + ".mkv"
    #    url = url.replace("master.m3u8",fname).replace(",.urlset","").replace(",","").replace("hls/","")
    #    xbmc.log('coudvideo file : ' + url, xbmc.LOGNOTICE )
    #except:
    #    pass
    
    return url
    
def get_media_url_yandex(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0','Referer':url})
    pattern = 'adaptive","size":\{\},"url":"([^"]+)'
    url = re.search(pattern,data).group(1)
    return url

def get_media_nofile(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    xbmc.log('Write file : ' + data, xbmc.LOGNOTICE ) 
    pattern = "scrubberUrl: *'([^']+)"
    url = "https://nofile.io" + re.search(pattern,data).group(1)
    url = url + "*"
    url = url.replace("/s*!","").replace("*!","")
    xbmc.log('******** nofile.io URL : ' + url, xbmc.LOGNOTICE ) 
    return url 

def get_media_trainbit(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    from bs4 import BeautifulSoup
    soup = BeautifulSoup(data, "html5lib")
    value1 = soup.find('input', {'name': '__VIEWSTATE'}).get('value')
    value2 = soup.find('input', {'name': '__VIEWSTATEGENERATOR'}).get('value')
    value3 = soup.find('input', {'name': '__EVENTVALIDATION'}).get('value')
    import requests
    post_fields = {'__VIEWSTATE': value1, '__VIEWSTATEGENERATOR' : value2, '__EVENTVALIDATION' : value3 }
    r = requests.post(url, data=post_fields)
    response_json = r.text.encode("utf8")
 
    return response_json
    
def get_mydaddy_video(url):
    import random
    rnd1 = str(random.randint(100,500))
    rnd2 = str(random.randint(10,99))
    
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0 rnd: ' + rnd1 + '.' + rnd2,'Referer':'https://hqporner.com' })
    patron = 'src="//mydaddy.cc/video/(.*?)/"'
    matches = re.compile(patron, re.DOTALL).findall(data)
    for idframe in matches:
        url = 'https://mydaddy.cc/video/' + idframe + '/'
    data2 = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0 rnd: ' + rnd1 + '.' + rnd2,'Referer':'https://hqporner.com' })
    patron = 'file: *"//(.*?).mp4", *label: *"([^"]+)'
    matches = re.compile(patron, re.DOTALL).findall(data2)
    urlx = ""
    for link, label in matches:
        if not urlx == "":
            urlx = urlx + " "
        
        if not label.find("360p")>-1 and not label.find("Default")>-1:
            label = label.replace(" Ultra HD","")
            label = label.replace(" Full HD","")
            label = label.replace(" HD","")
            label = label.replace("4K","2160p")
            label = label.replace("p60","p")
            
            urlx = urlx + 'https://' + link + '.mp4' + "/" + '[' + label + ']'
            
    #xbmc.log('***********URLX : ' + urlx, xbmc.LOGNOTICE )
    return urlx.strip()  

def get_media_svtv(url):
    
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    
    patron = 'name="op" *value="([^"]+)(.*?)name="usr_login" *value="([^"]+)(.*?)name="id" *value="([^"]+)(.*?)name="fname" *value="(.*?)"(.*?)name="referer" *value="(.*?)"(.*?)name="hash" *value="(.*?)"'
    matches = re.compile(patron, re.DOTALL).findall(data)
    
    for op, s1, login, s2, fid, s3, fname, s4, referer, s5, hasH in matches:    

        if not referer:
            referer = ''
            
        post_data = {'op':op,'usr_login':login,'id':fid,'fname':fname,'referer':referer,'hash':hasH}
    
    req = urllib2.Request(url=url, data=urllib.urlencode(post_data))
    req.add_header('User-Agent', 'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0')
    response = urllib2.urlopen(req, timeout=15)
    datax = response.read()
    
    try:
        patron = 'vvad\|(.*?)\|data\|tv(.*?)urlset\|(.*?)\|hls\|sources'
        matches = re.compile(patron, re.DOTALL).findall(datax)
        
        for dom, sep, ids in matches:
            DOM = "https://" + dom + ".svid.li"
            sids = ids.split("|")
            sids = sids[::-1]

        tok = ""
        
        for p in sids:
            tok = tok  + p + ","
            
            url = DOM + "/hls/" + tok + ".urlset/master.m3u8"
    except:
        patron = 'vvad\|(.*?)\|data\|tv(.*?)preload\|mp4\|(.*?)\|sources\|'
        matches = re.compile(patron, re.DOTALL).findall(datax)
        for dom, sep, tok in matches:
            DOM = "https://" + dom + ".svid.li"
            url = DOM + "/" + tok + "/" + "v.mp4"
        
    response.close()    
    return url

def get_okru_url(url):
    
    url = url.replace("/video/","/videoembed/")
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    video_urls = []
    
    if 'data-module="OKVideo"' in data:
        return 'http://www.google.it' # resituisco una url valida
    else:
        return 'http://indirizzochenonesiste.xyz'
    
    return url

def get_racaty_url(url):
    
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    #xbmc.log('***********racaty : ' + data, xbmc.LOGNOTICE )
    
    patron = 'name="op" *value="([^"]+)(.*?)name="id" *value="([^"]+)(.*?)name="rand" *value="(.*?)"(.*?)name="referer" *value="(.*?)"(.*?)name="method_free" *value="(.*?)"(.*?)name="method_premium" *value="(.*?)"'
    matches = re.compile(patron, re.DOTALL).findall(data)
    
    for op, s1, fid, s2, rand, s3, referer, s4, method_free, s5, method_premium in matches:    

        if not rand:
            rand = ''
        if not referer:
            referer = ''
        if not method_free:
            method_free = ''
        if not method_premium:
            method_premium = ''
            
        post_data = {'op':op,'id':fid,'rand':rand,'referer':referer,'method_free':method_free,'method_premium':method_premium}
    
    req = urllib2.Request(url=url, data=urllib.urlencode(post_data))
    req.add_header('User-Agent', 'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0')
    response = urllib2.urlopen(req, timeout=15)
    try:
        datax = response.read()
        patron = 'actions w-100 mt-4">(.*?)<a href="([^"]+)'
        matches = re.compile(patron, re.DOTALL).findall(datax)

        for s1, l in matches:
            link = l
            #xbmc.log('****** link : ' + l, xbmc.LOGNOTICE )
        response.close()
        return link        
    except:
        link = response.geturl()
        response.close()
        return link

def get_sportitalia(url):
    post_data = {}
    req = urllib2.Request(url=url, data=urllib.urlencode(post_data))
    req.add_header('User-Agent', 'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0')
    response = urllib2.urlopen(req, timeout=12)
    data = response.read().replace("\r", "")
    response.close()
    pattern = '"stream":"([^"]+)'
    url = re.search(pattern,data).group(1)
    url = url.replace("\\","")
    #xbmc.log('****** link SI: ' + url, xbmc.LOGNOTICE )
    return url

def get_videosky(url):
    data = OpenURL(url,headers={'User-Agent':'Mozilla/5.0 (X11; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0'})
    data = data.replace("\t", "")
    #xbmc.log('****** data sky: ' + data, xbmc.LOGNOTICE )
    patron = '"streaming_url": *"([^"]+)'
    matches = re.compile(patron, re.DOTALL).findall(data)
    for link in matches:
        url = link   
    return url
    
    
def urlresolve(url,check=False):
    if url.find("://openload.")>0 or url.find("://oload.")>0:
        from servers import openload
        video_urls = openload.get_video_url(url)
        url = video_urls[0][1]
    elif url.find("://verystream.com")>0 or url.find("://woof.tube")>0:
        from servers import verystream
        video_urls = verystream.get_video_url(url)
        url = video_urls[0][1]
    elif url.find("://streamcloud.eu")>0:
        from servers import streamcloud
        video_urls = streamcloud.get_video_url(url)
        url = video_urls[0][1]     
    elif url.find("sportitalia.com")>0:
        url = get_sportitalia(url)        
    elif url.find("://racaty.com")>0:
        url = get_racaty_url(url)
    elif url.find("mediafire.com")>0:
        url = get_media_url_mediafire(url)        
    elif url.find("/yadi.sk/")>0:
        url = get_media_url_yandex(url) 
    elif url.find("vidoza.net")>0 or url.find("cloudvideo.tv")>0:
        url = get_media_url_src(url)     
    elif url.find("my.pcloud.com")>0 or url.find("//pc.cd/")>0:
        url = get_media_url_pcloud(url)    
    elif url.find("stream.moe")>0:
        url = get_media_url_streammoe(url)
    elif url.find("akvideo.")>0:
        url = get_media_url_akvideo(url)        
    elif url.find("fastvideo.")>0:
        from servers import fastvideo
        video_urls = fastvideo.get_video_url(url)
        url = video_urls[0][1]
    elif url.find("rapidvideo.com")>0:
        url = get_media_url_rapidcom(url)
    elif url.find("rapidvideo.")>0:
        from servers import rapidvideo
        video_urls = rapidvideo.get_video_url(url)        
        url = video_urls[0][1]
    elif url.find("streamango.")>0:        
        from servers import streamango
        video_urls = streamango.get_video_url(url)        
        url = video_urls[0][1]
    elif url.find("speedvideo.")>0:
        from servers import speedvideo
        if not url.find("embed")>0:
            url = url.replace("speedvideo.net/","speedvideo.net/embed-")        
            if not url.find(".html")>0:
                url = url + ".html"
        video_urls = speedvideo.get_video_url(url)        
        url = video_urls[0][1]
    elif url.find("thevideo.me")>0:
        from servers import thevideome
        video_urls = thevideome.get_video_url(url)  
        url = video_urls[0][1]
    elif url.find("wstream.")>0:
        from servers import wstream
        video_urls = wstream.get_video_url(url)
        url = video_urls[0][1]
        #url = get_media_url_wstream(url)
    elif url.find("nowvideo.")>0:
        from servers import nowvideo
        url = url.replace("5nowvideo.com","nowvideo.li")
        url = url.replace("nowvideo.sx","nowvideo.li")
        video_urls = nowvideo.get_video_url(url)         
        url = video_urls[0][1]
    elif url.find("megadrive.")>0:
        from servers import megadrive
        video_urls = megadrive.get_video_url(url)         
        url = video_urls[0][1]
    elif url.find("megahd.")>0:
        from servers import megahd
        video_urls = megahd.get_video_url(url)         
        url = video_urls[0][1]
    elif url.find("//ok.ru/")>0 or url.find("//www.ok.ru/")>0:
        if check==False:
            from servers import okru
            video_urls = okru.get_video_url(url)         
            url = video_urls[0][1]
        else:
            url = get_okru_url(url)
    elif url.find("vidto.me")>0:
        from servers import vidtome
        if not url.find("embed")>0:
            url = url.replace("vidto.me/","vidto.me/embed-")
        video_urls = vidtome.get_video_url(url)         
        url = video_urls[0][1]
    elif url.find("vivo.sx")>0:    
        url = get_media_url_vivosx(url)
    elif url.find("streamcherry.com")>0:
        from servers import streamcherry
        video_urls = streamcherry.get_video_url(url)         
        url = video_urls[0][1]        
    elif url.find("sendit.cloud")>0:    
        url = get_media_url_sendit(url)
    elif url.find("//jwp.io")>0:
        url = get_media_nofile(url)
    elif url.find("//nofile.io")>0:
        url = get_media_nofile(url)        
    elif url.find("content.jwplatform.com")>0:
        url = get_media_url_jwp(url)
    elif url.find("supervideo.tv")>0:
        url = get_media_svtv(url)
    elif url.find("://video.sky.it")>0:
        url = get_videosky(url)        
    return url

def unshortenit(url):
    import unshortenit
    unshortened_uri, status = unshortenit.unshorten(url)
    return unshortened_uri
